/*
Copyright Renaud GICQUEL 2012  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.*;

import extThopt.Util;
import extThopt.PiloteStirling.SymAction;

import java.awt.Color;
import java.awt.event.*;
import java.awt.Dimension;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * <p>Titre : </p>
 * <p>Description : this class allows to calculate external mixture charts
 * The substances loaded are those of the project. 
 * 
 * The one in the combo box is selected for the chart
 * 
 * </p>
 * <p>Copyright : R. Gicquel (c) 2012</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */

public class CreateMixtureCharts  extends ExtPilot{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1831767940809942680L;
	JLabel jLabel1 = new JLabel();
  JComboBox jSubstanceSelector = new JComboBox();
  JLabel jLabel2 = new JLabel();
  JTextField Tmin_value = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField Tmax_value = new JTextField();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JTextField Pmax_value = new JTextField();
  JTextField Pmin_value = new JTextField();
  JLabel jLabel7 = new JLabel();
  JTextField pointNumber_value = new JTextField();
  JButton bCalculateTsChart = new JButton();
  JButton bCalculateHpChart = new JButton();
  JButton bSaveTsChart = new JButton();
  JButton bSaveHpChart = new JButton();
  JLabel jLabel8 = new JLabel();
  JTextField chartName_value = new JTextField();
  JButton bInitialize = new JButton();

  rg.corps.Corps selectedSubstance, lecorps;
  String nomCorps="";
	protected String []tS_ref= new String[20];//lgendes des diffrentes courbes - curve labels
	protected String []hP_ref= new String[20];//lgendes des diffrentes courbes - curve labels
	protected int []tS_val= new int[20];//nombre de valeurs des diffrentes courbes - number of curve values
	protected int []hP_val= new int[20];//nombre de valeurs des diffrentes courbes - number of curve values
	protected  double tS_Values[][][];//value array
	protected  double hP_Values[][][];//value array
	String dir_data="."+File.separator+"data"+File.separator;
	protected  String tab=new String("\t");
	protected  String ligne=new String("\n");
	int n_courbes;
	
    int nb_comp=0;
    String classType="";//type de classe - class type
    String systType="";//systme slectionn - selected system
    String[]nomComp=new String[0];
    double[] fractMol=new double[0];

  public CreateMixtureCharts() {
	setTitle("Mixture chart data");
    getContentPane().setLayout(null);
    setSize(new Dimension(571, 550));
    setVisible(false);
	jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
    jLabel1.setForeground(Color.blue);
    jLabel1.setText("Mixture chart creation interface");
    jLabel1.setBounds(65, 10, 349, 49);
    jSubstanceSelector.setToolTipText("Substance selector");
    jSubstanceSelector.setBounds(64, 74, 171, 30);
    jLabel2.setAlignmentY((float) 0.5);
    jLabel2.setText("Tmin (K)");
    jLabel2.setBounds(36, 140, 75, 25);
    Tmin_value.setText("150");
    Tmin_value.setBounds(113, 138, 72, 28);
    jLabel3.setBounds(218, 140, 76, 25);
    jLabel3.setAlignmentY((float) 0.5);
    jLabel3.setText("Tmax (K)");
    Tmax_value.setBounds(296, 136, 72, 28);
    Tmax_value.setText("435");
    jLabel4.setBounds(36, 176, 69, 25);
    jLabel4.setAlignmentY((float) 0.5);
    jLabel4.setText("Pmin (bar)");
    jLabel5.setAlignmentY((float) 0.5);
    jLabel5.setText("Pmax (bar)");
    jLabel5.setBounds(218, 173, 69, 25);
    Pmax_value.setText("50");
    Pmax_value.setBounds(296, 172, 72, 28);
    Pmin_value.setBounds(113, 174, 72, 28);
    Pmin_value.setText("0.1");
    jLabel7.setText("number of points");
    jLabel7.setBounds(36, 273, 99, 25);
    pointNumber_value.setText("100");
    pointNumber_value.setBounds(189, 270, 116, 28);
    bCalculateTsChart.setBounds(81, 326, 184, 31);
    bCalculateTsChart.setToolTipText("");
    bCalculateTsChart.setText("Calculate (T,s) chart");
    bCalculateHpChart.setText("Calculate (h,P) chart");
    bCalculateHpChart.setToolTipText("");
    bCalculateHpChart.setBounds(80, 390, 184, 31);
    bSaveTsChart.setText("Save (T,s) chart");
    bSaveTsChart.setToolTipText("");
    bSaveTsChart.setBounds(330, 326, 184, 31);
    bSaveTsChart.setFont(new java.awt.Font("Dialog", 1, 11));
    bSaveTsChart.setForeground(Color.red);
    bSaveHpChart.setForeground(Color.red);
    bSaveHpChart.setBounds(330, 390, 184, 31);
    bSaveHpChart.setToolTipText("");
    bSaveHpChart.setText("Save (h,P) chart");
    bSaveHpChart.setFont(new java.awt.Font("Dialog", 1, 11));
    jLabel8.setText("Chart name");
    jLabel8.setBounds(311, 79, 157, 19);
    chartName_value.setText("");
    chartName_value.setBounds(418, 77, 111, 24);
    bInitialize.setBounds(414, 22, 102, 33);
    bInitialize.setText("initialize");
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(Tmin_value, null);
    this.getContentPane().add(Tmax_value, null);
    this.getContentPane().add(jLabel3, null);
    this.getContentPane().add(Pmin_value, null);
    this.getContentPane().add(jLabel4, null);
    this.getContentPane().add(Pmax_value, null);
    this.getContentPane().add(jLabel5, null);
    this.getContentPane().add(pointNumber_value, null);
    this.getContentPane().add(jLabel7, null);
    this.getContentPane().add(bCalculateTsChart, null);
    this.getContentPane().add(bCalculateHpChart, null);
    this.getContentPane().add(bSaveTsChart, null);
    this.getContentPane().add(bSaveHpChart, null);
    this.getContentPane().add(jSubstanceSelector, null);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(jLabel8, null);
    this.getContentPane().add(chartName_value, null);
    this.getContentPane().add(bInitialize, null);
	SymAction lSymAction = new SymAction();
	jSubstanceSelector.addActionListener(lSymAction);
    bCalculateTsChart.addActionListener(lSymAction);
    bCalculateHpChart.addActionListener(lSymAction);
    bSaveTsChart.addActionListener(lSymAction);
    bSaveHpChart.addActionListener(lSymAction);
    bInitialize.addActionListener(lSymAction);
    type="mixture chart creator";
    tS_Values = new double[15][2][200];
    hP_Values = new double[15][2][200];

  }
  
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jSubstanceSelector)
				jSubstanceSelector_actionPerformed(event);
			else if (object == bCalculateTsChart)
				bCalculateTsChart_actionPerformed(event);
			else if (object == bCalculateHpChart)
				bCalculateHpChart_actionPerformed(event);
			else if (object == bSaveTsChart)
				bSaveTsChart_actionPerformed(event);
			else if (object == bSaveHpChart)
				bSaveHpChart_actionPerformed(event);
			else if (object == bInitialize)
				bInitialize_actionPerformed(event);
		}
	}	


  void jSubstanceSelector_actionPerformed(ActionEvent e) {
	   chartName_value.setText((String)jSubstanceSelector.getSelectedItem());
  }

  void bCalculateTsChart_actionPerformed(ActionEvent e) {
	  buildTs();
  }

  void bCalculateHpChart_actionPerformed(ActionEvent e) {
	  buildHp();
  }

  void bSaveTsChart_actionPerformed(ActionEvent e) {
	  saveTs();
  }

  void bSaveHpChart_actionPerformed(ActionEvent e) {
	  saveHp();
  }
  void bInitialize_actionPerformed(ActionEvent e) {
	  proj=getProjet();
		if(proj!=null){
		  jSubstanceSelector.removeAllItems();
		    for(int i=0;i<proj.getSubstanceList().length;i++){
		    	jSubstanceSelector.addItem(proj.getSubstanceList()[i]);
		    }
		}
  	}
  private void setupExtMixture(){
	  nomCorps=(String)jSubstanceSelector.getSelectedItem();
	  Object obj=rg.corps.Corps.createSubstance(nomCorps);
	  selectedSubstance =(rg.corps.Corps)obj;
  }

	/**
	 * Calculates the (T,s) background chart data
	 *  
	 */
  public void buildTs(){
	  setupExtMixture();
	  
      if(selectedSubstance != null){
         lecorps = selectedSubstance;
         double t0 = extThopt.Util.lit_d(Tmin_value.getText());
         double tmax = extThopt.Util.lit_d(Tmax_value.getText());
         int npoints = extThopt.Util.lit_i(pointNumber_value.getText());
         double pas = (tmax - t0) / (double)npoints;
         String nom_titre=chartName_value.getText();
         double Pmin=extThopt.Util.lit_d(Pmin_value.getText());
         double taux = Math.pow(extThopt.Util.lit_d(Pmax_value.getText()) / Pmin, 0.1);
         for(int j = -1; j < 9; j++){
        	 double P = Math.pow(taux, j+1 ) * Pmin;

              tS_ref[j+1] = "p = " + extThopt.Util.aff_d(P, 2);
              int nval = 0;
              double Tbulle=selectedSubstance.getSatTemperature(P, 0);
              double Trosee=selectedSubstance.getSatTemperature(P, 1);
              boolean liquid=true;
              double x=0;
              for(int i = 0; i < npoints + 1; i++){
                  double T = pas * (double)i + t0;
                  System.out.println("P 0: "+P+" T : "+T);
             	 if((T>Tbulle)&&(T<Trosee)){
            		 T=Tbulle;
            		 liquid=false;
            		 x=1;
            	 }
            	 if((T>Trosee)&&(liquid==false)){
            		 T=Trosee;
            		 liquid=true;
            		 x=1;
            	 }
                  selectedSubstance.CalcPropCorps(T, P, x);
                  Vector vProp=selectedSubstance.getSubstProperties();
            	  Double y=(Double)vProp.elementAt(6);
            	  double S=y.doubleValue();	 
                  System.out.println("P : "+P+" T : "+T+" S : "+S);
            	  
                  tS_Values[j + 1][0][i] = S;
                  tS_Values[j + 1][1][i] = T;
                  nval++;
              }

              tS_val[1 + j] = nval - 1;
          }

          for(int j = 0; j < 2; j++){
          	tS_ref[10] = "bulle " ;
          	tS_ref[11] = "rosee " ;
              int nval = 0;
              for(int i = 0; i < npoints + 1; i++){
                  double T = pas * (double)i + t0;
                  
                  double P=selectedSubstance.getSatPressure(T, j);
//                  selectedSubstance.CalcPropCorps(T, P, j);
                  if(j==0)selectedSubstance.CalcPropCorps(T-0.01, P, j);
                  else selectedSubstance.CalcPropCorps(T+0.01, P, j);

                  Vector vProp=selectedSubstance.getSubstProperties();
            	  Double y=(Double)vProp.elementAt(6);
            	  double S=y.doubleValue();	 
                  System.out.println("P ELV: "+P+" T : "+T+" S : "+S);

                  tS_Values[j + 10][0][i] = S;
                  tS_Values[j + 10][1][i] = T;
                  nval++;
             }

              tS_val[10 + j] = nval - 1;
          }
          n_courbes = 12;
      }
  }
	/**
	 * Calculates the (h,P) background chart data
	 *  
	 */
  public void buildHp(){
	  setupExtMixture();
      if(selectedSubstance != null){
          lecorps = selectedSubstance;
          double t0 = extThopt.Util.lit_d(Tmin_value.getText());
          double tmax = extThopt.Util.lit_d(Tmax_value.getText());
          int npoints = 100;
          double pas = (tmax - t0) / 10.;
          String nom_titre=chartName_value.getText();
          double Pmin=extThopt.Util.lit_d(Pmin_value.getText());
          double taux = Math.pow(extThopt.Util.lit_d(Pmax_value.getText()) / Pmin, 1./npoints);
          pas = (tmax - t0) / (double)10;
         for(int j = -1; j < 9; j++){
                 double T = pas * (j+1.) + t0;
                 hP_ref[j+1] = "T = " + Util.aff_d(T, 2);
                 int nval = 0;
                 double Pbulle=selectedSubstance.getSatPressure(T, 0);
                 double Prosee=selectedSubstance.getSatPressure(T, 1);
                 boolean liquid=true;
                 double x=0;
                 for(int i = 0; i < npoints + 1; i++){
                	 double P = Math.pow(taux, i)* Pmin;
                	 if((P>Pbulle)&&(P<Prosee)){
                		 P=Pbulle;
                		 liquid=false;
                		 x=1;
                	 }
                	 if((P>Prosee)&&(liquid==false)){
                		 P=Prosee;
                		 liquid=true;
                		 x=1;
                	 }
	                  selectedSubstance.CalcPropCorps(T, P, x);
	                  Vector vProp=selectedSubstance.getSubstProperties();
	            	  Double y=(Double)vProp.elementAt(5);
	            	  double H=y.doubleValue();	 
	                  System.out.println("P : "+P+" T : "+T+" H : "+H);
	                  hP_Values[j + 1][0][i] = H;
	                  hP_Values[j + 1][1][i] = P;
	                  nval++;
	             }
              hP_val[1 + j] = nval - 1;
          }

          for(int j = 0; j < 2; j++){
          	hP_ref[10] = "bulle " ;
          	hP_ref[11] = "rosee " ;
              int nval = 0;
              pas = (tmax - t0) / (double)npoints;
              for(int i = 0; i < npoints + 1; i++){
                  double T = pas*(double)i + t0;
                  double P=selectedSubstance.getSatPressure(T, j);                  
                  if(j==0)selectedSubstance.CalcPropCorps(T-0.01, P, j);
                  else selectedSubstance.CalcPropCorps(T+0.01, P, j);
                  Vector vProp=selectedSubstance.getSubstProperties();
            	  Double y=(Double)vProp.elementAt(5);
            	  double H=y.doubleValue();	 
                  System.out.println("P ELV: "+P+" T : "+T+" H : "+H);

                  hP_Values[j + 10][0][i] = H;
                  hP_Values[j + 10][1][i] = P;
                  nval++;
                  }

              hP_val[10 + j] = nval - 1;
          }
          n_courbes = 12;
      }
  }

	/**
	 * Saves the (T,s) background chart data
	 *  
	 */
  void saveTs(){
		String fichTs=chartName_value.getText()+"Ts.txt";

	    	File fich3=new File(dir_data, fichTs);
		    FileWriter out = null;
		try{
	        out = new FileWriter(fich3);
	        char[]data = new char[1000];
	        String h =new String("External mixture chart");

	        h="mixture data file"+ligne;
	        //dfinition du systme
	        lect_data_mel((String)jSubstanceSelector.getSelectedItem());
 	        h=h+(String)jSubstanceSelector.getSelectedItem()+tab
	        +classType+tab+systType+tab+extThopt.Util.aff_i(nb_comp)+tab;
            
            for (int i=0;i<nb_comp;i++){
                h=h+nomComp[i]+tab+Util.aff_d(fractMol[i])+tab;
            }
            h=h+ligne;
	        h=h+extThopt.Util.aff_i(n_courbes)+ligne;

		for(int j=0;j<n_courbes;j++){
			h=h+tS_ref[j]+ligne;
			h=h+extThopt.Util.aff_i(tS_val[j])+ligne;
	 
		    for(int i =0; i <=tS_val[j] ; i ++){
		    	h=h+Util.aff_d(tS_Values[j][0][i])+tab;
		    }
			h=h+ligne;
		    for(int i =0; i <=tS_val[j] ; i ++){
		    	h=h+Util.aff_d(tS_Values[j][1][i])+tab;
		    }
			h=h+ligne;
		}		 

	    data=h.toCharArray();
	    int data_length=h.length();
	    out.write(data,0,data_length);
	    out.flush();
	    out.close();

	} catch(IOException e) {
	    String message="Ill configured file";  
	    JOptionPane.showMessageDialog(this,message);
	    e.printStackTrace();}

	}
	/**
	 * Saves the (h,P) background chart data
	 *  
	 */
  void saveHp(){
		String fichHp=chartName_value.getText()+"Hp.txt";
	    	File fich3=new File(dir_data, fichHp);
		    FileWriter out = null;
		try{
	        out = new FileWriter(fich3);
	        char[]data = new char[1000];
	        String h =new String("External mixture chart");

	        h="mixture data file"+ligne;
	        //dfinition du systme
	        lect_data_mel((String)jSubstanceSelector.getSelectedItem());
 	        h=h+(String)jSubstanceSelector.getSelectedItem()+tab
	        +classType+tab+systType+tab+extThopt.Util.aff_i(nb_comp)+tab;
            
            for (int i=0;i<nb_comp;i++){
                h=h+nomComp[i]+tab+Util.aff_d(fractMol[i])+tab;
            }
            h=h+ligne;
	        h=h+extThopt.Util.aff_i(n_courbes)+ligne;

		for(int j=0;j<n_courbes;j++){
			h=h+hP_ref[j]+ligne;
			h=h+Util.aff_i(hP_val[j])+ligne;
	 
		    for(int i =0; i <=hP_val[j] ; i ++){
		    	h=h+Util.aff_d(hP_Values[j][0][i])+tab;
		    }
			h=h+ligne;
		    for(int i =0; i <=hP_val[j] ; i ++){
		    	h=h+Util.aff_d(hP_Values[j][1][i])+tab;
		    }
			h=h+ligne;
		}		 

	    data=h.toCharArray();
	    int data_length=h.length();
	    out.write(data,0,data_length);
	    out.flush();
	    out.close();

	} catch(IOException e) {
	    String message="Ill configured file";  
	    JOptionPane.showMessageDialog(this,message);
	    e.printStackTrace();}

	}
  	/**
	 * Gets the informations on the external substance from the data in file mel_ext.txt
	 *  
	 */
	 public void lect_data_mel(String nomCorps){
		 StringBuffer nomfich= new StringBuffer("mel_ext.txt"); 
			File fich_mel = new File(dir_data,nomfich.toString());
		    FileReader flux_fich=null;
		    BufferedReader flux_tamp=null;
			try{
				flux_fich = new FileReader(fich_mel);
				flux_tamp = new BufferedReader(flux_fich);
				String ligne_data;

				ligne_data = flux_tamp.readLine();//premire ligne de commentaires
				StringTokenizer st = new StringTokenizer(ligne_data,"\t");

				//lignes de donnes
				int i_dat=-1;
				StringBuffer test=new StringBuffer("");
			    while (((ligne_data = flux_tamp.readLine())!= null)&& (!(test.toString().equals("Fin")))){
					i_dat+=1;
					//nom du gaz compos
					st = new StringTokenizer(ligne_data,"\t");
					String mel_externe = st.nextToken();
					if(mel_externe.equals(nomCorps)){
						classType=st.nextToken();//type de classe
			            systType=st.nextToken();
			            Vector vComp=new Vector();
	  					while(st.hasMoreTokens()){
	  						String compose = st.nextToken();
	  						System.out.println("compose : "+compose);
	  						vComp.addElement(compose);
	  			        }

			            nb_comp=vComp.size();
			            nomComp=new String[nb_comp];
			            fractMol=new double[nb_comp];
			            System.out.println("nb_comp : "+nb_comp);
						for(int i=0;i<nb_comp;i++){
							String data=(String)vComp.elementAt(i);
							StringTokenizer st2 = new StringTokenizer(data,";");
							nomComp[i]=st2.nextToken();
			                fractMol[i]=Util.lit_d(st2.nextToken());
				        }
						break;
					}
			    }
		
			flux_tamp.close();
			flux_fich.close();

		} 
		catch(FileNotFoundException e) {
		    e.printStackTrace();
		}
		catch(IOException e) {
		    e.printStackTrace();
		}
	}

}

